﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr135_1
{
    // Класс с несколькими индексаторами: 
    class MyClass{
        // Закрытое целочисленное поле:
        private int[] nums;
        // Конструктор класса с одним аргументом: 
        public MyClass(int size) {
            // Создание массива: 
            nums = new int[size];
            // Заполнение массива:
            for (int k = 0; k < nums.Length; k++) {
                // Использование индексатора: 
                this[k] = k + 1;
            }
        }
        // Переопределение метода ToString(): 
        public override string ToString(){
            // Текстовая переменная:
            string txt = "Содержимое объекта:\n";
            // Формирование текстовой строки: 
            for (int k = 0; k < nums.Length; k++){
                // Используется индексатор с целочисленным 
                // индексом:
                txt += this[k] + (k == nums.Length - 1? "\n": " ");
            }
            // Результат метода: 
            return txt;
        }
        // Индексатор с целочисленным индексом: 
        public int this[int k]{
            // Аксессор для считывания значения: 
            get {
                return nums[k % nums.Length];
            }
            // Аксессор для присваивания значения: 
            set {
                nums[k % nums.Length] = value;
            }
        }
        // Индексатор с символьным индексом: 
        public int this[char s]{
            // Аксессор для считывания значения: 
            get {
                // Используется индексатор с целочисленным 
                // индексом: 
                return this[s - 'a'];
            }
            // Аксессор для присваивания значения: 
            set {
                // Используется индексатор с целочисленным
                // индексом:
                this[s - 'a'] = value;
            }
        }
        // Индексатор с целочисленным и текстовым индексом: 
        public int this[int k, string t] {
            // Аксессор для считывания значения: 
            get {
                // Используется индексатор с символьным индексом: 
                return this[t[k]];
            }
            // Аксессор для присваивания значения: 
            set {
                // Используется индексатор с символьным индексом: 
                this[t[k]] = value;
            }
        }
        // Индексатор с текстовым и целочисленным индексом:
        public int this[string t, int k] {
            // Аксессор для считывания значения: 
            get {
                // Использование индексатора с целочисленным и 
                // текстовым индексом: 
                return this[k, t];
            }
            // Аксессор для присваивания значения: 
            set {
                // Использование индексатора с целочисленным и 
                // текстовым индексом: 
                this[k, t] = value;
            }
        }
    }
    
    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Целочисленная переменная: 
            int n = 6;
            // Создание объекта:
            MyClass obj = new MyClass(n);
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            // Поэлементное отображение содержимого массива: 
            for (int k = 0; k < n + 3; k++) {
                // Объект с целочисленным индексом:
                Console.Write(obj[k] + " ");
            }
            Console.WriteLine("\n");
            // Объект с целочисленным индексом:
            obj[1] = 7; 
            obj[n + 3] = 8;
            Console.WriteLine(obj);
            // Объект с символьным индексом:
            obj['a'] = 9;
            obj['k'] = 0;
            // Проверка содержимого объекта:
            Console.WriteLine(obj);
            Console.WriteLine("Проверка:");
            // Поэлементное отображение содержимого массива: 
            for(char s = 'a'; s < 'a' + n + 3; s++) {
                // Объект с символьным индексом:
                Console.Write(obj[s] + " ");
            }
            Console.WriteLine("\n");
            // Объект с целочисленным и текстовым индексом: 
            obj[4, "alpha"] = 0; 
            obj["bravo", 0] = 6;
            // Проверка содержимого массива:
            Console.WriteLine(obj);
            // Текстовая переменная: 
            string txt = "abc";
            Console.WriteLine("Проверка:");
            // Отображение значений элементов массива: 
            for (int k = 0; k < txt.Length; k++)
            {
                // Объект с двумя индексами:
                Console.WriteLine(obj[k, txt] + ": " + obj[txt, k]);
            }
            // Задержка:
            Console.ReadLine();
        }
    }
}
